///////////////////////////////////////////////////////////
////// GibPascal pascal_string.c
////// Released under the GPLv3
////// Written by:
//////    Michael Gibson
//////    (c)2003-2021
///////////////////////////////////////////////////////////

#include <string.h>
#include <stdio.h>

char variable_names_string[256][256];
char variable_type_string[256];
char value_of_variables_string[256][256];


////////////////////////////////////////////////////////////////////
////// concat()
/////////////////////////////////////////////////////////////////
char *pascal_concat(char *command,int debug)
{
  int loop=0;
  int loop2=0;
  int loop3=0;
  char tempstr[255];
  char value_n[255];
  char value_a[120],t_value_a[120];
  char value_b[120],t_value_b[120];
  do{
    loop++;
  }while(command[loop] != '(');
  if(command[loop+1]=='\''){
    loop=loop+2;
    do{
      if(command[loop]!='\'') value_a[loop2]=command[loop];
      if(command[loop]=='\0'){
          printf("Pascal Error - Parse error with concat\n");
          break;
      }
      loop++;
      loop2++;
    }while(command[loop] != '\'');
    value_a[loop2]='\0';
    loop++;
  }
  else{
    loop++;
    do{
      if( command[loop] != ',' ){
       tempstr[loop2]=command[loop];
       loop++;
       loop2++;
      }
    }while ( command[loop] != ',' );
    tempstr[loop2]='\0';
    for(loop3=0;loop3<256;loop3++){
      if( strcmp(tempstr,variable_names_string[loop3])==0) break;
    }
    strcpy(value_a,value_of_variables_string[loop3]);
    if(debug==1)printf("**[concat]tempstr ='%s'\n",tempstr);
  }
  if(debug==1)printf("**[concat]value of value_a = '%s'\n",value_a);
  loop2=0;
  if(debug==1)printf("**[concat]value of check command[loop]='%c'\n",command[loop]);
  if(command[loop+1]=='\''){
    loop=loop+2;
    do{
      if(command[loop]!='\'') value_b[loop2]=command[loop];
      if(command[loop]=='\0'){
          printf("Pascal Error - Parse error with concat\n");
          break;
      }
      loop++;
      loop2++;
    }while(command[loop] != '\'');
    value_b[loop2]='\0';
  }
  else{
    loop++;
    do{
      if( command[loop] != ')' ){
       tempstr[loop2]=command[loop];
       loop++;
       loop2++;
      }
    }while ( command[loop] != ')' );
    tempstr[loop2]='\0';
    for(loop3=0;loop3<256;loop3++){
      if( strcmp(tempstr,variable_names_string[loop3])==0) break;
    }
    if(debug==1)printf("**[concat]tempstr ='%s'\n",tempstr);
    strcpy(value_b,value_of_variables_string[loop3]);
  }
  if(debug==1)printf("**[concat]value of value_b = '%s'\n",value_b);
  strcpy(value_n,value_a);
  strcat(value_n,value_b);
}

///////////////////////////////////////////////////////////
////// concat_set()
///////////////////////////////////////////////////////////
char *concat_set(char *command, int debug)
{
  int loop=0;
  int loop2=0;
  int loop3=0;
  int x;
  int numofchars=0;
 
  char value[255][255];
  char set_value[255][255];
  char c_return;
  char newvalue[255];

  char operation[19];
  int numofops=0;

  strncpy(operation,"                 \0",18);

  do{
    loop++;
  }while(command[loop] != '=');
  loop++;

  do{
    if(command[loop+1]!='\''){
      do{
        value[loop2][loop3]=command[loop];
     
        loop++;
        loop3++;
      }while(command[loop]!='+' && command[loop]!=';');
      value[loop2][loop3]='\0';

      for(x=0;x<=256;x++){
        if (strstr(value[loop2],variable_names_string[x])!='\0' && strlen(variable_names_string[x])>=1){
            strcpy(set_value[loop2],value_of_variables_string[x]);
            if(debug==1)printf("**[Concat_Set]var '%s' found.\n",value[loop2]);
            if(debug==1)printf("**[concat_set]value set from variable '%s'\n",set_value[loop2]);

        }
      } //end for
    }
    else{
      loop=loop+2;
      do{
        if(command[loop]!='\'') value[loop2][loop3]=command[loop];
        loop++;
        loop3++;
      }while(command[loop]!='\'' && command[loop]!=';');
      value[loop2][loop3]='\0';
      strcpy(set_value[loop2],value[loop2]);
      if(debug==1)printf("**[concat_set]value set from quote '%s'\n",set_value[loop2]);
    }


    if(command[loop]=='+'){
       operation[numofops]='+';
       numofops++;
       loop++;
    }

    loop2++;
    loop3=0;

    numofchars++;
  }while(command[loop] !=';');

 for(x=0;x<=256;x++){
    if(set_value[x][1]!='\0')strcat(newvalue,set_value[x]);
 }

 strcat(newvalue,"\0");

}

/////////////////////////////////////////////////////////////
////// delete()
////////////////////////////////////////////////////////////
void pascal_delete(char *stread,int indent, int debug){

 int loop, loop2, v_loop, temp_loop,int_place, int_count;
 char tempstr[99],tempstring[99];
 char delete_string[99];
 char char_place[2], char_count[2];
 char new_string[99];
 loop=indent;
 loop2=0;
 do{
   if(stread[loop] != ','){         //checks to see if ok to read
     tempstr[loop2]=stread[loop];   //reads in variable name
     loop++;
     loop2++;
   }
 }while(stread[loop] != ',');
 tempstr[loop2]='\0';
 if(debug==1)printf("**(delete) variable name: '%s'\n",tempstr);

 //// find variable that matches ////
 for(v_loop=0;v_loop<=256;v_loop++){
   if(strcmp(tempstr,variable_names_string[v_loop])==0) break;
 }
 strcpy(delete_string,value_of_variables_string[v_loop]);
 if(debug==1)printf("**(delete) insert string = '%s'\n",delete_string);

 loop++;

 if(stread[loop+1]==','){
   char_place[0]=stread[loop];
   int_place=atoi(char_place);
   loop=loop+2;
 }
 else{
    char_place[0]=stread[loop];
    char_place[1]=stread[loop+1];
    int_place=atoi(char_place);
    loop=loop+3;
  }

  if(debug==1)printf("**(delete) column insert at %d\n",int_place);
  int_place=int_place - 1;

  if(stread[loop+1]==')'){
    char_count[0]=stread[loop];
    char_count[1]='\0';
    int_count=atoi(char_count);
  }
  if(stread[loop+1]!=')'){
    char_count[0]=stread[loop];
    char_count[1]=stread[loop+1];
    char_count[2]='\0';
    int_count=atoi(char_count);
  }
  if(debug==1)printf("**(delete) count '%s' = '%d'\n",char_count,int_count);

  temp_loop=0;
  do{
    tempstring[temp_loop]=value_of_variables_string[v_loop][temp_loop + int_place + int_count];
    temp_loop++;
  }while(value_of_variables_string[v_loop][temp_loop + int_place + int_count]!='\0');

  tempstring[temp_loop]='\0';
  if(debug==1)printf("**(insert) string being moved: '%s'\n",tempstring);

  strncpy(new_string,value_of_variables_string[v_loop],int_place);
  new_string[int_place]='\0';
  //strcat(new_string,insert_string);
  strcat(new_string,tempstring);
  strcpy(value_of_variables_string[v_loop],new_string);

}
